About the Scheduler

The Novell® Desktop Management Scheduler allows you to set up different actions to run on your workstation.

About Actions

An action is an object that contains a list of one or more action items (for example, EXEs, DLLs, ActiveX*, and JavaScript*). The action applies only to the workstation from which you are running the workstation Scheduler.

Actions and action items can be given a priority, allowing you to specify which action or action item should run first, second, and so forth. You can also schedule actions to automatically run when a workstation event occurs or periodically at a certain time.

You determine the amount of time each action or action item has to complete. If the action cannot occur at the specified time, you can indicate whether to discontinue it, retry it every minute, or have it rescheduled.

If the action does not complete within a specified amount of time, you can indicate that the action should be terminated. If the action does complete successfully, you can indicate that the action should not be run again.

You can also specify if an action should dial a number before any action item runs.

If you have the necessary rights, you can view and edit details or properties associated with an action. You can also delete an action, disable or enable an action, or run an action immediately even if it was scheduled to run at a later date or time or upon the occurrence of a given event.

You can remove, disable or enable, reorder, and view or modify properties associated with action items.

Rights for Running Actions

For actions to have the proper rights to modify the workstation's environment, administrators must assign you the appropriate workstation access rights.

Using the Scheduler in Windows NT

In Windows NT*, a user does not need to be logged in to the workstation or the network for the action to happen. That is, the workstation can be at the NetWare® login window and the action will run in the background. This allows the action to take place even when no one is at the workstation. However, the workstation must be on for the action to occur. If it is not on when an action starts, Scheduler reschedules the action within a block of time called the startup block of time. If the workstation is not turned on within this time, you can indicate that the action be retried every minute, rescheduled to occur during the next interval, or dropped.

Microsoft SAGE Compatibility

The Scheduler is compatible with Microsoft* SAGE for Windows* 95/98 and can run SAGE-aware programs.

Related Topics

A trademark symbol (®, ™, etc.) denotes a Novell Trademark. An asterisk (*) denotes a third-party trademark. For more information, see Legal Notices.


To add an action

Setting up an action item requires that you add the action item to the list of action items. The network administrator (or other user with the Supervisor right) can do this in ConsoleOne™ and then push the action item to one or more user workstations. Users can also set up action items to run on their individual workstations by using the workstation Scheduler.

  1. Load the Scheduler (run wmsched.exe).

  2. Click Add to display the Action Properties dialog box.

  3. Fill in the fields of the General page.

  4. Click Items > Add.

  5. Fill in the required information in the Item Properties dialog box > click OK.

  6. Click OK in the Action Properties dialog box.

The action is added to the Action list on the Scheduler. You can now do any of the following:

Specify when this action should take place (Schedule page).

Add items to this action (Items page).

Specify what happens if this action cannot occur (Advanced page).

Related Topics

A trademark symbol (®, ™, etc.) denotes a Novell Trademark. An asterisk (*) denotes a third-party trademark. For more information, see Legal Notices.


To add an action item

This process assumes that you have previously created an action to contain the action items.

  1. In the Scheduler, select an action > click Properties > click Items > click Add.

  2. Browse to find the desired action item > click the item > click Open.

  3. If you want to define a working directory other than the one automatically set (where the action item is located), enter the path in the Working Directory field.

The Working Directory field must specify a local device. Network paths cannot be used as working directories.

  4. In the Parameters field, enter any parameters for the action item.

  5. Specify the priority of the action item (optional).

  6. If the action item must be completed within a certain time, click Terminate Item If Still Running After > specify the number of minutes within which the action item must finish.

Specify the time needed for all action items to run to completion if Run in Order is checked. If it is not checked, specify the amount of time required based on the longest running action item.

  7. To save the settings and continue editing the action, click Apply.

or

When you are done with the action item's properties, click OK.

The action item now appears in the Action item list.

If any action items are scheduled to run now and you click OK or Apply, they will run.

  8. Repeat Steps 2 through 7 until you have finished adding items.

Related Topics


To determine what to do if an action could not be run

  1. Load the Scheduler (run wmsched.exe).

  2. Click an action.

  3. Click Properties > Advanced.

  4. Select what is to occur if the action could not be run .

  5. Enable any of the following options:

Disable the Action After Completion

Terminate Action If Still Running After ? Minutes

Randomly Dispatch Action During Scheduled Time Period

Reboot After Completion

  6. To save the settings and exit, click Apply > OK.

Related Topics


To disable or enable an action

  1. Click an action.

  2. Click Enable/Disable.

Related Topics


To disable or enable an action item

  1. Click an action > Properties.

  2. Click the Items page > an action item > Disable/Enable.

Related Topics


To remove an action

This procedure cannot be undone. When you click Close, you are not prompted to verify the removal of the action. If you remove an action that you need later, you must add it again.

  1. Click an action.

  2. Click Remove.

Related Topics


To remove an action item

This procedure cannot be undone. When you click Close, you are not prompted to verify the removal of the action item. If you remove an action item that you need later, you must add it again.

  1. Click an action > Properties.

  2. Click Items > an action item > Remove.

Related Topics


To run an action immediately

  1. Click an action.

  2. Click Run Now.

Related Topics


To schedule an action to run

  1. Select the action you want to schedule.

  2. Click Properties > Schedule.

  3. Click the desired scheduling option.

  4. Configure the time for the action.

  5. Click OK.

The schedule you define applies to every action item contained in the action and overrides the package schedule.

Related Topics


To view or edit the details or properties of an action

  1. Click an action > Properties.

  2. Click one of the pages containing the details or properties associated with this action.

  3. Make the necessary changes.

  4. Click OK.

Related Topics


To view or edit the details or properties of an action item

  1. Click an action > Properties.

  2. Click Item > an action item > Properties.

  3. Make the necessary changes.

  4. Click OK.

Related Topics


To view or edit user-defined action item properties

  1. Open the Scheduler on a workstation.

  2. Select an action item > click Properties.

  3. Fill in the fields on each page:

General page

Items page

Schedule page

Advanced page

Related Topics


What To Do If an Action Runs Too Long field

What To Do If an Action Runs Too Long

You can set a time limit on how long an action should run.

If your action items are set to run in order, then the number of minutes to specify is the total time required by all action items. If the action items are not set to run in order, then the number of minutes to specify is the longest time required by an action item.

To specify the amount of time the action is allowed to run,

  1. Click Terminate Item If Still Running After ? Minutes(s).

  2. Specify the number of minutes.

Related Topics


What To Do If the Action Fails To Complete or Run field

What To Do If the Action Fails To Complete or Run

If an action does not run successfully, you have several alternatives:

  • Disable the action to prevent it from running again.

  • Retry every minute (as long as it is within the specified time to start block). All other scheduling information is ignored until the action can be started successfully.

  • Ignore the error and reschedule the action to start at the next scheduled interval. For example, if the action is scheduled to run every Monday and the action fails to run on a certain Monday, the scheduler reschedules it to run on the next Monday.


What To Do When the Action Completes field

What To Do When the Action Completes

After the action completes, you have several options to indicate what the Scheduler should do next.

Disable the Action after Completion

Causes the system to disable the action after it runs so that it cannot be run again.

Terminate Action if Still Running After ? Minutes

Stops the action from running after it has been running for the number of minutes you specifyin the Minutes field. This feature prevents an action that has stopped responding/running without completing from continuously tying up the system. However, checking this box only affects actions that are not currently running. You cannot use this check box to terminate an action that has already been loaded by the Scheduler and is currently running. Also, if the action you are running (such as a DOS batch file) opened a DOS window, the DOS window is not automatically closed after the action has completed, unless you added the /c parameter in the Parameters field when you originally added the action item.

Randomly Dispatch Action during Scheduled Time Period

Lets the system determine when it is best to run the action within the time period you established.

Reboot after Completion

Causes the system to reboot the workstation after the action has run.

Prompt the User Before Rebooting

Causes the system to prompt the workstation's user for approval before rebooting. This option is available only if Reboot after Completion is checked.


Trademarks, Copyright, Disclaimer, and Patents

Legal Notices

Copyright © 1996-2001 Novell, Inc. All rights reserved. No part of this publication may be reproduced, photocopied, stored on a retrieval system, or transmitted without the express written consent of the publisher.

U.S. Patent Nos. 5,349,642; 5,594,863; 5,633, 931; 5,692,129; 5,761,499; 5,781,733; 5,859,978. U.S. and Foreign Patents Pending.

Novell, Inc. makes no representations or warranties with respect to the contents or use of this documentation and specifically disclaims any express or implied warranties of merchantability or fitness for any particular purpose. Further, Novell, Inc. reserves the right to revise this publication and to make changes to its content, at any time, without obligation to notify any person or entity of such revisions or changes.

Further, Novell, Inc. makes no representations or warranties with respect to any software, and specifically disclaims any express or implied warranties of merchantability or fitness for any particular purpose. Further, Novell, Inc. reserves the right to make changes to any and all parts of Novell software, at any time, without any obligation to notify any person or entity of such changes.

Novell Trademarks

Novell is a registered trademark of Novell, Inc. in the United States and other countries.

NDS is a registered trademark of Novell, Inc. in the United States and other countries.

NetWare is a registered trademark of Novell, Inc. in the United States and other countries.

ConsoleOne is a trademark of Novell, Inc.

Third-Party Trademarks

All third-party trademarks are property of their respective owners.

Conventions

In Novell documentation, a greater than symbol (>) is used to separate actions within a step and items in a cross-reference path.


Action Properties: Advanced

Use the fields on this page to determine what happens to the action's schedule if it did not complete or run within the given time, or when it successfully completes.

To access the Advanced tab, click an action name > Properties.

Related Topics


Action Properties: General

Use the fields on this page to add or change basic information about the related action.

Name

The name of the action. In ConsoleOne™, the name includes the action object's full context. In the workstation Scheduler, the name is whatever you enter in this field.

Priority

The order in which the action is run. Higher priority actions are run first. If two actions have the same priority, the first one encountered in the action list (contained in the window that is first displayed when the Scheduler is loaded) runs first. The priority selected applies to all action items contained in this action, unless the action item overrides it.

Impersonation

The workstation access rights to grant to all action items contained by this action. (Windows NT* only.)

Action Remains Persistent after Reboot

The action is saved to the workstation, allowing the Scheduler to reactivate the action at the appointed time when the workstation is rebooted. If this option is not selected, the action is lost when you exit Windows NT. (Workstation Scheduler only.)

Related Topics

A trademark symbol (®, ™, etc.) denotes a Novell Trademark. An asterisk (*) denotes a third-party trademark. For more information, see Legal Notices.


Action Properties: Items

Lets you add an action item or manage action items contained within an action.

You can access the Items tab by either clicking an action in the list and then clicking Properties to bring up the action's property page, or by clicking Add to add an action.

Related Topics


Action Properties: Schedule

Use the fields on this page to specify when the action is to run and provide details that the system needs about when the action runs.

The Schedule tab contains five scheduling options: Event, Daily, Weekly, Monthly, and Yearly. The option you choose and the settings you associate with it determine when the action is run.

You can use only one scheduling option at a time. For example, if the Daily option is selected, all other options are ignored unless you use the options found on the Advanced tab.

Time units are shown according to a 24-hour clock (for example, 9:00 for 9 a.m. and 13:30 for 1:30 p.m.).

The Scheduler ignores the scheduling information until the action can be started successfully.

You can choose the following scheduling options:

  • Event

  • Daily

  • Weekly

  • Monthly

  • Yearly

Related Topics


General Tab - Impersonation field

Impersonation

Determines how the action will run on the workstation. Each option affects the action and all action items contained by this action.

  • Interactive User: Causes the action to run in the context of the user who is logged in to that workstation. It gives the action whatever rights the workstation's User object has been assigned. Usually, this includes just the user access rights. If the default user rights have been granted, the action cannot change settings that require administrative rights. (For Windows* 95/98, selecting Interactive User specifies that the user's rights are used for access.)

  • System: Causes the action to run in the background as a local service. When the action is dispatched, it then runs under the context of that local system. The action is granted administrative rights to the workstation. Use this option only if the actions do not require any user input. (For Windows 95/98, selecting System specifies that the workstation's rights are used for access.)

  • Unsecure System (Windows NT* only): Allows actions to run in the background, but interact with the user if necessary. You can use this option for applications that require user interaction. This method is unsecured, because the operating system permits address mappings between the user and system space (which it normally does not allow). You can use this option when the protected areas of the registry and file system need modifications and require a user interface to execute. For security reasons, this option should be avoided.

A trademark symbol (®, ™, etc.) denotes a Novell Trademark. An asterisk (*) denotes a third-party trademark. For more information, see Legal Notices.


Action List

Each action on the list includes various items of information associated with that action. This information is listed in the following columns.

Name

The name of the action item. This name was entered in the Name field on the Item page when the action item was added.

Working Directory

Generally, this is the path where the executable file for this action item is located. It can be a different path if the program requires it. This information was entered in the Working Directory field of the Action Properties Item tab when this action was added.

Parameters

The parameters to pass to the action item. For more information, see the documentation associated with the executable file specified in the Working Directory field.

Priority

The importance assigned to this action in relation to the user's access to the workstation.

Terminate Time

The length of time this action can run before the system stops it. The assumption is that if it takes longer than a specified time to run, there might be a problem associated with running this action and the action should be stopped.

Completion Event

Displays when the action finished running.

Currently Running

Displays whether this action is currently being run on this workstation.

Return Code

Displays the system's response associated with running this action.


Action Remains Persistent After a Reboot

Saves the action to the local machine. This allows the Scheduler to reactivate the action at the appointed time. If this option is not enabled, the action is lost when the machine is turned off, so it cannot be rescheduled.


Add button

Add

Adds an action item to the list. You must add at least one action item to an action.


Browse button

Browse

Lets you navigate the file system to find an action item.


Item Properties - Parameters field

Parameters

The path the system can use for command line arguments to be sent to the application. For example, if you want to launch notepad.exe and have it automatically open the readme.txt file, you would put readme.txt in the Parameters field.


Schedule Tab - Daily

Daily

Lets you schedule an action to occur on one or more days between the specified start and end times. Optionally, it allows you to repeat the action at regular intervals after the action successfully starts. For example, on Monday, Wednesday, and Friday, you could start the action between 12:30 and 13:00 and run it every 10 minutes.

Run this Action on the Following Days

Specify the days of the week when the action is to run.

Start the Action Between the Hours of ? (HH:MM)

Specify a range of time within which this action can be started.

Repeat the Action Every ? (HH:MM:SS)

Specify the length of time the system is to wait before it repeats this action.


Properties button

This button allows you to view or edit the properties of the selected action.


Advanced Tab - Disable the Action After Completion field

Disable the Action After Completion

Disables the rescheduling mechanism for this action after all action items have started successfully.


Items Tab - Disable/Enable button

Disable/Enable

Toggles between enabling or disabling an action item.


Schedule Tab - Event

Event

Event scheduling allows you to determine what kind of workstation event causes your action to run. To schedule the action based on an event, click Event and choose from the following list of recognized events:

  • Scheduler Service Startup: Runs the action when the Scheduler starts up.

  • User Login: Runs the action after the user has successfully logged in but before the login scripts are executed.

  • User Desktop Is Active: Runs the action after the login scripts have completed (does not apply to Windows* 95/98).

  • Workstation Is Locked: Runs the action when the workstation is locked (does not apply to Windows 95/98).

  • Workstation Is Unlocked: Runs the action when the workstation is unlocked (does not apply to Windows 95/98).

  • Screen Saver Is Activated: Runs the action when the screen saver is activated.

  • User Logout: Runs the action before logout is completed.

  • System Shutdown: Runs the action after all other applications have successfully closed, but before the system shuts down.

You cannot choose the Scheduler Service Startup event or System Shutdown event to start the action if you are going to run the action with the rights of an interactive user. When these events take place, the interactive user is not yet authenticated. Scheduler Service Startup and System Shutdown require System rights.

A trademark symbol (®, ™, etc.) denotes a Novell Trademark. An asterisk (*) denotes a third-party trademark. For more information, see Legal Notices.


If Action Could Not Be Run

If the system cannot run the action, you can specify what should occur.

  • Disable the Action: Disables the action so it will not run again (unless you enable it again).

  • Retry Every Minute: Causes the system to keep trying to run this action every 60 seconds.

  • Ignore the Error and Reschedule Normally: Causes any error that occurred while the action was running to be ignored and the action to be rescheduled for a later date/time.


Schedule Tab - Monthly

Monthly

Lets you choose the day of the month when this action runs, as well as the time to start this action. For example, you can choose to run this action on every fourth day of the month, between the hours of 8:00 and 10:15. You specify the time range using a 24-hour clock. If you prefer, you can choose to have the action run on the last day of the month, regardless of how many days there are in the month.

Run this Action Once a Month on Day __ of the Month

Specify the day of the month on which the system is to automatically run this action. Click one of the available radio buttons:

  • On Day _ of the Month. This action will be run on the specified day.

  • On the Last Day of the Month. This action will be run on the last day of the month regardless of how many days there are in the month.

Start this Action Between the Hours of ? (HH:MM)

Specify the exact hour (HH) and minute (MM) this action is to start.


Item Properties - Name field

Name

Enter the name of the program to run. This program must exist on the user’s path to be run as an action item.


Priority field (Item Properties, General tab)

Priority

Both actions and action items have four priorities available: Action Default, Above Normal, Normal, and Below Normal. Action items can assume the same priority as the Action object that contains them--in other words, they take on the action's default priority. Alternatively, they can override the default by using one of the three other priority settings.

If the action occurs during normal business hours, it should be assigned a Below Normal priority so it will not affect the user’s workstation performance.

If two or more actions or action items have the same priority, the first one defined (the one that appears first in the list) has precedence over the others.


Prompt the User Before Rebooting field

Prompt the User Before Rebooting

(ConsoleOne™ snap-in Scheduler only) Allows the user to decide whether the workstation is to be rebooted now that the scheduled action has run. For this option to be available, you must enable Reboot after Completion.

A trademark symbol (®, ™, etc.) denotes a Novell Trademark. An asterisk (*) denotes a third-party trademark. For more information, see Legal Notices.


Properties button

Properties

Lets you view or edit the properties of an action item.


Randomly Dispatch Action During Scheduled Time Period field

Randomly Dispatch Action During Scheduled Time Period

(ConsoleOne™ snap-in Scheduler only) Directs the system to send this action to the associated workstations at a random time during the scheduled time.

A trademark symbol (®, ™, etc.) denotes a Novell Trademark. An asterisk (*) denotes a third-party trademark. For more information, see Legal Notices.


Reboot After Completion field

Reboot After Completion

(ConsoleOne™ snap-in Scheduler only) Reboots the associated workstation after the scheduled action has run. You can also enable Prompt the User before Rebooting to let the user decide whether the workstation is to be rebooted after the scheduled action has run.

A trademark symbol (®, ™, etc.) denotes a Novell Trademark. An asterisk (*) denotes a third-party trademark. For more information, see Legal Notices.


Remove button

Remove

Removes an action item from the list. You cannot undo this action.


Items Tab - Run Items in Order Listed field

Run Items in Order Listed

If you want each action item to run to completion before the next one is executed, click Run Items in Order Listed > an action item > rearrange the existing order of the action items in the list.

If this option is enabled, the order in which you arrange these action items overrides the individual action item's priority settings. If this option is not enabled, all action items are executed in the order specified by their individual priorities, although one action item does not necessarily need to be completed before the next one begins.


Scheduler - Novell Workstation Management - main window

Scheduler - Novell Workstation Management

This dialog box displays a list of actions currently scheduled to run. The following information is displayed for each action:

Action: The name of the action.

Next Run: The date and time the action is scheduled to run next.

Last Run: The date and time the action was previously run.

Currently Running: Whether the action is currently running.

Priority: What priority has been given to running this action in relation to the user's access to the workstation.

Impersonation: The access rights the action and its associated action rights have to the workstation.

Terminate Time: How long the action is allowed to run before the system stops it.

Persistent: Whether this action is to be part of this workstation session only or is to be retained for future use as well.

Advanced Options: Additional options that apply to this action, such as what to do if the action could not be run.

Add

Displays the Action Properties dialog box where you can add a new action to the list.

Remove

Deletes or removes a selected action from the list of scheduled actions.

Properties

Displays the Action Properties dialog box for the selected action.

Disable/Enable

Toggles between enabling or disabling a selected action.

Run Now

Runs the selected action immediately instead of waiting until its scheduled time.

Refresh

Updates the information related to each action in the list of actions.

Close

Ends this workstation session of Scheduler and closes the Scheduler utility.

Related Topics


Item Properties - Terminate Action If Still Running After ? Minutes field

Terminate Action If Still Running After ? Minutes

Terminates the action if it is still running after the number of minutes you specify. The action is then rescheduled to run at the next scheduled time.

To set a time limit on how long the action should run, click the check box. The number of minutes, which you specify in the Minutes field, should be the total time required by the action itself as well as by all action items associated with the action, where applicable. If you do not specify sufficient time for the action and all associated action items to run, your action items might not have enough time to complete their tasks.

This option is available only through Add (an action item) or through the action item Properties.


Start the Action Between the Hours of ? (HH:MM)

Defines a block of time when the action item can start. It does not specify when the action item should be terminated.


Schedule Tab - Weekly

Weekly

Lets you schedule an action on a particular day of the week.

Run this Action Once a Week On

Identifies day of the week when you want the action to run.

Start this Action Between the Hours of ? (HH:MM)

Identifies the exact hour (HH) and minute (MM) to start this action.


Item Properties - Working Directory field

Working Directory

This field is automatically filled in when you browse for an action item. It is set to the directory that the action item is in. You can specify a different working directory by entering the path in this field.


Schedule Tab - Yearly

Yearly

Lets you determine the time and the day of the month to perform the action.

Run the Action Once a Year on Day ? of ?

Specify the day of the month and the month of the year for the action to run.

Start the Action between the Hours of ? and ?

Using a 24-hour clock, specify the hour and minute of the earliest time this action is to be started, and then the hour and minute of the latest time this action is to be started. For example, choose 17:30 to begin the action no earlier than 5:30 p.m. and 20:00 to begin the action no later than 8:00 p.m.


Parameters Field for Action Items

If you are adding an action item that is a DOS batch file, a DOS window must be opened to run it. The DOS window will close when the batch file has finished running if you include the /c parameter. You must put the /c parameter, followed by a space, in front of the name of the batch file in the Parameters field.

For example, to run a DOS batch file called test_c.bat, make the following entries on the Item Properties dialog box for the action item when you add the action item:

Name: cmd.exe (the name of the Windows NT* command that opens a DOS window) or start (the name of the Windows* 95/98 command that opens a DOS window).

Working Directory: Leave this field blank unless you need to specify where either cmd.exe or start is located.

Parameters: /c test_c.bat (you must include the full filename with its extension, and you must use the /c parameter if you want the DOS window to close as soon as the batch file has finished running).

Priority: Leave at Action Default, or choose one of the other settings.

A trademark symbol (®, ™, etc.) denotes a Novell Trademark. An asterisk (*) denotes a third-party trademark. For more information, see Legal Notices.